#![allow(dead_code, unused_imports)]

use rustfuck::frontend::int_program::IntProgram;
use rustfuck::program::exec::{EofMode, ExecContext};
use rustfuck::program::BfProgram;

const BF_SRC: &str = include_str!("./LostKingdom.bf");
const INPUT: &str = include_str!("./LostKingdom.in");
const OUTPUT: &str = include_str!("./LostKingdom.out");


#[test]
fn lost_kingdom() {
    let program = BfProgram::parse_from_src(BF_SRC.as_bytes()).unwrap();
    let mut out = Vec::new();

    program.execute(&mut out, INPUT.as_bytes(), EofMode::NoChange).unwrap();
    assert_eq!(out, OUTPUT.as_bytes());
}
